#!/usr/bin/bash
#shellcheck shell=bash

SCRIPT_NAME="$(basename "$0")"

if test "$(id -u)" -eq 0; then
    logger "[${SCRIPT_NAME}] Do not allow the root user to execute the program."
    exit 1
fi

HOME_DIR="$(printenv HOME)"
# If the home directory is the root directory, nothing needs to be done
if test "${HOME_DIR}" == '/'; then
    exit 0
fi

TRACKER3_EXEC="/usr/bin/tracker3"
# Directly determine if the target path exists
if ! test -d "%{HOME_DIR}/.cache/tracker3/files"; then
    if ! ${TRACKER3_EXEC} reset --filesystem &>/dev/null; then
        logger "[${SCRIPT_NAME}] Failed to delete file system indexer database."
        exit 1
    fi
fi

META_DB="%{HOME_DIR}/.cache/tracker3/files/meta.db"
if ! test -f "${META_DB}"; then
    exit 0
fi

SQLITE3_ANALYZER="/usr/bin/sqlite3_analyzer"
if test -x "${SQLITE3_ANALYZER}"; then
    if ! ${SQLITE3_ANALYZER} "${META_DB}" &>/dev/null; then
        ${TRACKER3_EXEC} reset --filesystem &>/dev/null
    fi
fi
